<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_template_listing_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanTemplateListingType".
 *
 * Columns in table "scan_template_listing_type" available as properties of the model,
 * followed by relations of table "scan_template_listing_type" available as properties of the model.
 *
 * @property integer $id
 * @property integer $listing_type_id
 * @property integer $scan_template_id
 * @property string $type
 * @property integer $max_age
 * @property string $weight
 * @property string $section
 * @property integer $provider_primary_only
 * @property integer $provider_secondary_only
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 *
 * @property ListingType $listingType
 * @property ScanTemplate $scanTemplate
 * @property Account $addedByAccount
 */
abstract class BaseScanTemplateListingType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_template_listing_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanTemplateListingType|ScanTemplateListingTypes', $n);
    }

    public static function representingColumn()
    {
        return 'type';
    }

    public function rules()
    {
        return array(
            array('listing_type_id, scan_template_id, weight, section, provider_primary_only, provider_secondary_only, date_added, added_by_account_id, date_updated', 'required'),
            array('listing_type_id, scan_template_id, max_age, provider_primary_only, provider_secondary_only, added_by_account_id', 'numerical', 'integerOnly'=>true),
            array('type', 'length', 'max'=>100),
            array('weight', 'length', 'max'=>4),
            array('section', 'length', 'max'=>12),
            array('type, max_age', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, listing_type_id, scan_template_id, type, max_age, weight, section, provider_primary_only, provider_secondary_only, date_added, added_by_account_id, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'listingType' => array(self::BELONGS_TO, 'ListingType', 'listing_type_id'),
            'scanTemplate' => array(self::BELONGS_TO, 'ScanTemplate', 'scan_template_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'listing_type_id' => null,
            'scan_template_id' => null,
            'type' => Yii::t('app', 'Type'),
            'max_age' => Yii::t('app', 'Max Age'),
            'weight' => Yii::t('app', 'Weight'),
            'section' => Yii::t('app', 'Section'),
            'provider_primary_only' => Yii::t('app', 'Provider Primary Only'),
            'provider_secondary_only' => Yii::t('app', 'Provider Secondary Only'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'listingType' => null,
            'scanTemplate' => null,
            'addedByAccount' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('scan_template_id', $this->scan_template_id);
        $criteria->compare('type', $this->type, true);
        $criteria->compare('max_age', $this->max_age);
        $criteria->compare('weight', $this->weight, true);
        $criteria->compare('section', $this->section, true);
        $criteria->compare('provider_primary_only', $this->provider_primary_only);
        $criteria->compare('provider_secondary_only', $this->provider_secondary_only);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
